unit MAIN;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, Menus,
  StdCtrls, Dialogs, Buttons, Messages, ExtCtrls, ComCtrls, StdActns,
  ActnList, ToolWin, ImgList, ComPortUnit, SafeListsUnit, WinDebugMonUnit, DateUtils, Proc,
  iniFiles;

const
  INPUT_MSG = WM_USER+1;
  ERROR_MSG = WM_USER+2;
  COMPORT_DISCONNECT = WM_USER + 3;
  CONNECT_MSG = WM_USER + 4;
  MONITOR_MSG = WM_USER + 5;
  DEBUG_MON_MSG = WM_USER + 6;
  SHOW_CONNECT = WM_USER + 10;

type
  TMainForm = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Window1: TMenuItem;
    Help1: TMenuItem;
    N1: TMenuItem;
    FileExitItem: TMenuItem;
    WindowCascadeItem: TMenuItem;
    WindowTileItem: TMenuItem;
    WindowArrangeItem: TMenuItem;
    HelpAboutItem: TMenuItem;
    OpenDialog: TOpenDialog;
    Edit1: TMenuItem;
    WindowMinimizeItem: TMenuItem;
    StatusBar: TStatusBar;
    ActionList1: TActionList;
    WindowCascade1: TWindowCascade;
    WindowTileHorizontal1: TWindowTileHorizontal;
    WindowArrangeAll1: TWindowArrange;
    WindowMinimizeAll1: TWindowMinimizeAll;
    HelpAbout1: TAction;
    WindowTileVertical1: TWindowTileVertical;
    WindowTileItem2: TMenuItem;
    ToolBar2: TToolBar;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    ToolButton10: TToolButton;
    ToolButton11: TToolButton;
    ImageList1: TImageList;
    N2: TMenuItem;
    ActionConnect: TAction;
    ActionDebugWin: TAction;
    COM1: TMenuItem;
    ActionIMU_Settings: TAction;
    IMU1: TMenuItem;
    ActionChannelControls: TAction;
    N3: TMenuItem;
    Action_OSD_Settings: TAction;
    OSD1: TMenuItem;
    ActionADCSettings: TAction;
    N4: TMenuItem;
    ActionBatParams: TAction;
    N5: TMenuItem;
    ActionStabControls: TAction;
    N6: TMenuItem;
    ActionWinHardConfig: TAction;
    N7: TMenuItem;
    ActionExportConfig: TAction;
    ActionLoadConfig: TAction;
    ActionExportLogs: TAction;
    N8: TMenuItem;
    N9: TMenuItem;
    N10: TMenuItem;
    N11: TMenuItem;
    N12: TMenuItem;
    ActionCalibrate: TAction;
    ActionCalibrate1: TMenuItem;
    ActionSaveSettings: TAction;
    N14: TMenuItem;
    N13: TMenuItem;
    ActionMonGyro: TAction;
    N15: TMenuItem;
    N16: TMenuItem;
    ActionMonAccel: TAction;
    ActionMonBaro: TAction;
    N17: TMenuItem;
    N18: TMenuItem;
    ActionMonMag: TAction;
    ActionMonStab: TAction;
    ActionMonImu: TAction;
    N19: TMenuItem;
    N20: TMenuItem;
    IMU2: TMenuItem;
    ActionMonGps: TAction;
    GPS1: TMenuItem;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton9: TToolButton;
    ToolButton12: TToolButton;
    procedure HelpAbout1Execute(Sender: TObject);
    procedure FileExit1Execute(Sender: TObject);
    procedure ActionConnectExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ActionDebugWinExecute(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ActionIMU_SettingsExecute(Sender: TObject);
    procedure ActionChannelControlsExecute(Sender: TObject);
    procedure Action_OSD_SettingsExecute(Sender: TObject);
    procedure ActionADCSettingsExecute(Sender: TObject);
    procedure ActionBatParamsExecute(Sender: TObject);
    procedure ActionStabControlsExecute(Sender: TObject);
    procedure ActionWinHardConfigExecute(Sender: TObject);
    procedure ActionExportConfigExecute(Sender: TObject);
    procedure ActionLoadConfigExecute(Sender: TObject);
    procedure ActionExportLogsExecute(Sender: TObject);
    procedure ActionCalibrateExecute(Sender: TObject);
    procedure ActionSaveSettingsExecute(Sender: TObject);
    procedure ActionMonGyroExecute(Sender: TObject);
    procedure ActionMonAccelExecute(Sender: TObject);
    procedure ActionMonBaroExecute(Sender: TObject);
    procedure ActionMonMagExecute(Sender: TObject);
    procedure ActionMonStabExecute(Sender: TObject);
    procedure ActionMonImuExecute(Sender: TObject);
    procedure ActionMonGpsExecute(Sender: TObject);
  private
    { Private declarations }
    procedure ShowConnect(var Message: TMessage); message SHOW_CONNECT;
    procedure InputMessage(var Message: TMessage); message INPUT_MSG;
    procedure MonitorMessage(var Message: TMessage); message MONITOR_MSG;
    procedure DebugMonMessage(var Message: TMessage); message DEBUG_MON_MSG;
    procedure ErrorMessage(var Message: TMessage); message ERROR_MSG;
    procedure ConnectMessage(var Message: TMessage); message CONNECT_MSG;
    procedure ComportDisconnect(var Message: TMessage); message COMPORT_DISCONNECT;


  public
    { Public declarations }

    ComPort : TComPort;

    Input : TSafeStringList;
    Monitor : TSafeStringList;
    DebugMon : TSafeStringList;
    Output: TSafeStringList;
    Error : TSafeStringList;


    ConnectStatus: boolean;


    MonWindow: TWinDebugMon;

    ADC_mon: string;
    PPM_mon: string;
    MAG_mon: string;
    GYRO_mon: string;
    ACCEL_mon: string;
    BARO_mon: string;
    STAB_mon: string;
    EKF_mon: string;
    GPS_mon: string;

    CurrentVersion: string;

    Config: TIniFile;

    function  GetNextInputString: string;
    procedure ClearInput;
    procedure AddToOutput(s: string);
    procedure SetActions(state: boolean);

  end;

var
  MainForm: TMainForm;

implementation


{$R *.dfm}

uses  about, DlgConnectUnit, WinImuSettingsUnit,
  WinChannelControlsUnit, WinOSDControlsUnit, WinAdcSettingsUnit,
  WinBatSettingsUnit, WinStabControlUnit, WinHardConfigUnit,
  WinMemsCalibrateUnit, WinSaveSettingsUnit, WinExportLogsUnit,
  WinBackupConfigUnit, WndLoadSettingsUnit, WinMonGyroUnit,
  WinMonAccelUnit, WinMonBaroUnit, WinMonMagUnit, WinMonStabUnit,
  WinMonImuUnit, WinMonGpsUnit;


procedure TMainForm.HelpAbout1Execute(Sender: TObject);
begin
  AboutBox:=TAboutBox.Create(Self);
  AboutBox.ShowModal;
end;

procedure TMainForm.FileExit1Execute(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.ActionConnectExecute(Sender: TObject);
  var
    Con: TDlgConnect;
    s: string;
    ts: TDateTime;
    OpenMon: integer;
begin
  if not ConnectStatus then begin
    Con:= TDlgConnect.Create(MainForm);
    try


      Con.PortNum.Text:=Config.ReadString('CONNECT','Port','COM18');
      Con.SpeedNum.Text:=Config.ReadString('CONNECT','PortSpeed','115200');
      OpenMon:= Config.ReadInteger('CONNECT','OpenDebugMon',1);
      if OpenMon=1 then Con.OpenMon.Checked:=true else Con.OpenMon.Checked:=false;
      if Con.ShowModal = mrOk then begin
        if Con.OpenMon.Checked then ActionDebugWinExecute(self);

        Input.Clear;
        Monitor.Clear;
        DebugMon.Clear;
        Error.Clear;
        Output.Clear;
        ComPort := TComPort.Create(false,self,'\\.\'+Con.PortNum.Text,StrToInt(Con.SpeedNum.Text));
        Output.Add(#13#10);
        ts:=Now;
        while true do begin
          // ?
          if Error.Count>0 then begin
            ShowMessage(' : '+Error.Text);
            exit;
          end;
          if Input.Count >0 then begin
            Input.GetAccess;
            try
              s:=Input[0];
              Input.Delete(0);
              if s='=>' then break;


            finally
              Input.ReleaseAccess;
            end;
          end;


          if MilliSecondsBetween(Now,ts) > 10000 then begin
            //  
            break;
          end;

        end;
        //   
        //   
        if s='=>' then begin
              //  .  
              Output.Add('echo off'#13#10); //  ,      
              ts:=Now;
              while true do begin
                // ?
                if Error.Count>0 then begin
                  ShowMessage(' : '+Error.Text);
                  exit;
                end;
                if Input.Count >0 then begin
                  Input.GetAccess;
                  try
                    s:=Input[0];
                    Input.Delete(0);
                    if s='=>' then break;


                  finally
                    Input.ReleaseAccess;
                  end;
                end;


                if MilliSecondsBetween(Now,ts) > 10000 then begin
                  //  
                  break;
                end;

              end;
              if s='=>' then begin
              //  .  
                  Config.WriteString('CONNECT','Port',Con.PortNum.Text );
                  Config.WriteString('CONNECT','PortSpeed',Con.SpeedNum.Text);
                  OpenMon:= Config.ReadInteger('CONNECT','OpenDebugMon',1);
                  if Con.OpenMon.Checked then Config.WriteInteger('CONNECT','OpenDebugMon',1) else Config.WriteInteger('CONNECT','OpenDebugMon',0);

              end
              else
                ShowMessage(' :    ');

        end else
              ShowMessage(' :    ');
      end;
    finally
      Con.Free;
    end;
  end;
end;

procedure TMainForm.FormCreate(Sender: TObject);
var
    ConfFile: string;
begin
  ConnectStatus:=false;
  ComPort:=nil;
  MonWindow:=nil;
  
  Input := TSafeStringList.Create;
  Monitor := TSafeStringList.Create;
  DebugMon := TSafeStringList.Create;
  Output:= TSafeStringList.Create;
  Error := TSafeStringList.Create;


  CurrentVersion:=GetMyExeVersion(Application.ExeName);
  Caption:=Caption+' :: '+CurrentVersion;
  ConfFile:=  ExtractFilePath(Application.ExeName)+'FlyingBrain_CP.conf';
  Config:=TiniFile.Create(ConfFile);

  SetActions(false);

  PostMessage(self.Handle,SHOW_CONNECT,0,0);
end;

procedure TMainForm.ShowConnect(var Message: TMessage);
begin
  ActionConnectExecute(self);
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  Config.Free;
  Input.Free;
  Monitor.Free;
  DebugMon.Free;
  Output.Free;
  Error.Free;
end;

procedure TMainForm.ErrorMessage(var Message: TMessage);
begin
  StatusBar.SimpleText :=' : '+Error.Text;
  Error.Clear;
  SetActions(false);
end;

procedure TMainForm.InputMessage(var Message: TMessage);
begin
//
end;

procedure TMainForm.MonitorMessage(var Message: TMessage);
var
   s: string;
begin
  Monitor.GetAccess;
  try
    while  Monitor.Count>0 do begin
       s:= Monitor[0];
       Monitor.Delete(0);
    end;
  finally
    Monitor.ReleaseAccess;
  end;
end;


procedure TMainForm.DebugMonMessage(var Message: TMessage);
var
   s: string;
begin
  DebugMon.GetAccess;
  try
    while  DebugMon.Count>0 do begin
       s:= DebugMon[0];
       DebugMon.Delete(0);
       if  MonWindow<>nil then MonWindow.AddMessage(s);
    end;
  finally
    DebugMon.ReleaseAccess;
  end;
end;


procedure TMainForm.ComportDisconnect(var Message: TMessage);
begin
  StatusBar.SimpleText:=' ';
  SetActions(false);
  ConnectStatus:=false;
end;

procedure TMainForm.ConnectMessage(var Message: TMessage);
begin
  StatusBar.SimpleText:=' ';
  SetActions(true);
  ConnectStatus:=true;
end;

procedure TMainForm.ActionDebugWinExecute(Sender: TObject);
begin
  if MonWindow=nil then TWinDebugMon.Create(Application)
  else MonWindow.WindowState := wsNormal;
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if ConnectStatus and (ComPort<>nil) then begin
     ComPort.doExit:=true;
     while  ConnectStatus do begin
       Application.ProcessMessages;
      //   
     end;
  end;
  if ComPort<>nil then ComPort.Free;
  Action:=caFree;
end;

procedure TMainForm.ActionIMU_SettingsExecute(Sender: TObject);
begin
  if WinImuSettings<>nil then WinImuSettings.WindowState := wsNormal
  else
    WinImuSettings:= TWinImuSettings.Create(Application);
end;

function TMainForm.GetNextInputString: string;
begin
  Result:='';
  Input.GetAccess;
  try
    while Input.Count>0 do begin
      Result:=Trim(Input[0]);
      Input.Delete(0);
      if Result<>'' then break;
    end;
  finally
    Input.ReleaseAccess;
  end;
end;

procedure TMainForm.ClearInput;
begin
  Input.GetAccess;
  try
    Input.Clear;
  finally
    Input.ReleaseAccess;
  end;
end;

procedure TMainForm.AddToOutput(s: string);
begin
  Output.GetAccess;
  try
    Output.Add(s);
  finally
    Output.ReleaseAccess;
  end;

end;

procedure TMainForm.ActionChannelControlsExecute(Sender: TObject);
begin
  if WinChannelControls<>nil then WinChannelControls.WindowState := wsNormal
  else
    WinChannelControls:= TWinChannelControls.Create(Application);

end;

procedure TMainForm.Action_OSD_SettingsExecute(Sender: TObject);
begin
  if WinOSDControls<>nil then WinOSDControls.WindowState := wsNormal
  else
    WinOSDControls:= TWinOSDControls.Create(Application);

end;

procedure TMainForm.ActionADCSettingsExecute(Sender: TObject);
begin
    if WinAdcSettings<>nil then WinAdcSettings.WindowState := wsNormal
  else
    WinAdcSettings:= TWinAdcSettings.Create(Application);

end;

procedure TMainForm.ActionBatParamsExecute(Sender: TObject);
begin
    if WinBatSettings<>nil then WinBatSettings.WindowState := wsNormal
  else
    WinBatSettings:= TWinBatSettings.Create(Application);
end;

procedure TMainForm.ActionStabControlsExecute(Sender: TObject);
begin
    if WinStabControl<>nil then WinStabControl.WindowState := wsNormal
  else
    WinStabControl:= TWinStabControl.Create(Application);
end;

procedure TMainForm.ActionWinHardConfigExecute(Sender: TObject);
begin
    if WinHardConfig<>nil then WinHardConfig.WindowState := wsNormal
  else
    WinHardConfig:= TWinHardConfig.Create(Application);
end;

procedure TMainForm.ActionExportConfigExecute(Sender: TObject);
begin
    if WinBackupConfig<>nil then WinBackupConfig.WindowState := wsNormal
  else
    WinBackupConfig:= TWinBackupConfig.Create(Application);
end;

procedure TMainForm.ActionLoadConfigExecute(Sender: TObject);
begin
    if WndLoadSettings<>nil then WndLoadSettings.WindowState := wsNormal
  else
    WndLoadSettings:= TWndLoadSettings.Create(Application);
end;

procedure TMainForm.ActionExportLogsExecute(Sender: TObject);
begin
    if WinExportLogs<>nil then WinExportLogs.WindowState := wsNormal
  else
    WinExportLogs:= TWinExportLogs.Create(Application);
end;

procedure TMainForm.ActionCalibrateExecute(Sender: TObject);
begin
    if WinMemsCalibrate<>nil then WinMemsCalibrate.WindowState := wsNormal
  else
    WinMemsCalibrate:= TWinMemsCalibrate.Create(Application);
end;

procedure TMainForm.ActionSaveSettingsExecute(Sender: TObject);
begin
    if WinSaveSettings<>nil then WinSaveSettings.WindowState := wsNormal
  else
    WinSaveSettings:= TWinSaveSettings.Create(Application);
end;

procedure TMainForm.ActionMonGyroExecute(Sender: TObject);
begin
    if WinMonGyro<>nil then WinMonGyro.WindowState := wsNormal
  else
    WinMonGyro:= TWinMonGyro.Create(Application);
end;

procedure TMainForm.ActionMonAccelExecute(Sender: TObject);
begin
    if WinMonAccel<>nil then WinMonAccel.WindowState := wsNormal
  else
    WinMonAccel:= TWinMonAccel.Create(Application);
end;

procedure TMainForm.ActionMonBaroExecute(Sender: TObject);
begin
    if WinMonBaro<>nil then WinMonBaro.WindowState := wsNormal
  else
    WinMonBaro:= TWinMonBaro.Create(Application);
end;

procedure TMainForm.ActionMonMagExecute(Sender: TObject);
begin
    if WinMonMag<>nil then WinMonMag.WindowState := wsNormal
  else
    WinMonMag:= TWinMonMag.Create(Application);
end;

procedure TMainForm.ActionMonStabExecute(Sender: TObject);
begin
    if WinMonStab<>nil then WinMonStab.WindowState := wsNormal
  else
    WinMonStab:= TWinMonStab.Create(Application);
end;

procedure TMainForm.ActionMonImuExecute(Sender: TObject);
begin
    if WinMonImu<>nil then WinMonImu.WindowState := wsNormal
  else
    WinMonImu:= TWinMonImu.Create(Application);
end;

procedure TMainForm.ActionMonGpsExecute(Sender: TObject);
begin
    if WinMonGps<>nil then WinMonGps.WindowState := wsNormal
  else
    WinMonGps:= TWinMonGps.Create(Application);
end;

procedure TMainForm.SetActions(state: boolean);
begin
  ActionConnect.Enabled:= not state;
  ActionDebugWin.Enabled:=state;
  ActionIMU_Settings.Enabled:=state;
  ActionChannelControls.Enabled:=state;
  Action_OSD_Settings.Enabled:=state;
  ActionADCSettings.Enabled:=state;
  ActionBatParams.Enabled:=state;
  ActionStabControls.Enabled:=state;
  ActionWinHardConfig.Enabled:=state;
  ActionExportConfig.Enabled:=state;
  ActionLoadConfig.Enabled:=state;
  ActionExportLogs.Enabled:=state;
  ActionCalibrate.Enabled:=state;
  ActionSaveSettings.Enabled:=state;
  ActionMonGyro.Enabled:=state;
  ActionMonAccel.Enabled:=state;
  ActionMonBaro.Enabled:=state;
  ActionMonMag.Enabled:=state;
  ActionMonStab.Enabled:=state;
  ActionMonImu.Enabled:=state;
  ActionMonGps.Enabled:=state;
end;

end.
