unit WinMonGyroUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Buttons;

type
  TWinMonGyro = class(TForm)
    Panel1: TPanel;
    Label2: TLabel;
    FileName: TEdit;
    SpeedButton1: TSpeedButton;
    Label3: TLabel;
    CheckBox1: TCheckBox;
    SaveDialog1: TSaveDialog;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    Monitor: TMemo;
    Timer1: TTimer;
    Panel2: TPanel;
    Panel3: TPanel;
    Graf: TImage;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    F: TFileStream;
    acc_old_x: integer;
    acc_old_y: integer;
    acc_old_z: integer;
    split: TStringlist;
  end;

var
  WinMonGyro: TWinMonGyro;

implementation

uses MAIN;

{$R *.dfm}

procedure TWinMonGyro.FormCreate(Sender: TObject);
begin
  split:= TStringlist.Create;
end;

procedure TWinMonGyro.FormDestroy(Sender: TObject);
begin
  if Timer1.Enabled then begin
    MainForm.AddToOutput('mon off gyro'+#13#10);
    Timer1.Enabled:=false;
    if f<>nil then FreeAndNil(f);

  end;
  split.Free;
  WinMonGyro:=nil;
end;

procedure TWinMonGyro.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action:=caFree;
end;

procedure TWinMonGyro.SpeedButton1Click(Sender: TObject);
begin
  if SaveDialog1.Execute then begin
     FileName.Text:=SaveDialog1.FileName;
  end;
end;

procedure TWinMonGyro.SpeedButton2Click(Sender: TObject);
var
   R: TRect;
begin
  if not CheckBox1.Checked then begin
    f:=nil;
    MainForm.AddToOutput('mon on gyro'+#13#10);
    Timer1.Enabled:=true;

  end else
  if Length(FileName.Text)>0 then begin
    if FileExists(FileName.Text) then
      f:= TFileStream.Create(FileName.Text, fmOpenReadWrite	 or fmShareDenyNone )
    else
      f:= TFileStream.Create(FileName.Text, fmCreate or fmShareDenyNone	 );

    f.Size:=0;

    MainForm.AddToOutput('mon on gyro'+#13#10);
    Timer1.Enabled:=true;

  end else begin
     ShowMessage('  ');
     exit;
  end;



  Graf.Canvas.Brush.Color:=$00ffffff;
  Graf.Canvas.Pen.Color:=$00ff8000;
  R.Left:=0;
  R.Right:=Graf.Width-1;
  R.Top:=0;
  R.Bottom:=Graf.Height - 1;
  Graf.Canvas.FillRect(R);
  Graf.Canvas.MoveTo(0,(Graf.Height-1) div 2);
  Graf.Canvas.lineTo(Graf.Width - 1,(Graf.Height-1) div 2);

end;

procedure TWinMonGyro.SpeedButton3Click(Sender: TObject);
begin
  if f<>nil then FreeAndNil(f);
  MainForm.AddToOutput('mon off gyro'+#13#10);
  Timer1.Enabled:=false;
end;

procedure TWinMonGyro.Timer1Timer(Sender: TObject);
var
   str:string;
   D,S: TRect;

   w,h,h2: integer;
   z,dz,x,dx,y,dy: double;
begin
  str:=MainForm.GYRO_mon;
  Monitor.Lines.Add(str);
  if f<>nil then begin
    str:=str+#13#10;
    f.Write(str[1],Length(str));
  end;
  while  Monitor.Lines.Count>2000 do Monitor.Lines.Delete(0);

  // 
  W:=Graf.Width;
  H:=Graf.Height;
  H2:=H div 2;

  D.Left:=0;
  D.Top:=0;
  D.Right:=W-5;
  D.Bottom:=H-1;

  S.Left:=5;
  S.Top:=0;
  S.Right:=W-0;
  S.Bottom:=H-1;

  Graf.Canvas.Brush.Color:=$00ffffff;

  Graf.Canvas.CopyRect(D,Graf.Canvas,S);

//  Graf.Canvas.FillRect(S);
{  Graf.Canvas.Brush.Color:=$0000ffff;
  Graf.Canvas.FillRect(S);
}
  //  4  

  S.Left:=W-5;
  S.Top:=0;
  S.Right:=W-0;
  S.Bottom:=H-1;



  Graf.Canvas.FillRect(S);
  //  

  //  
  str:=trim(str);
  str:=StringReplace(str,' ',#13#10,[rfReplaceall]);
  str:=StringReplace(str,'.',',',[rfReplaceall]);
  split.Text:=str;

//  dz:= H2 / 6;
  dz := 1;
  z:=StrToFloat(split[3]);
  z:=z * dz;

//  dx:= H2 / 6;
  dx := 1;
  x:=StrToFloat(split[1]);
  x:=x * dx;

//  dy:= H2 / 6;
  dy :=1;
  y:=StrToFloat(split[2]);
  y:=y * dy;

  //    
  Graf.Canvas.Pen.Color:=$00ff0000;
  Graf.Canvas.Pen.Style:= psSolid;
  Graf.Canvas.MoveTo(W-6,acc_old_z + H2);
  Graf.Canvas.LineTo(W-1,trunc(z) + H2);
  acc_old_z:=trunc(z);

  Graf.Canvas.Pen.Color:=$0000ff00;
  Graf.Canvas.Pen.Style:= psSolid;
  Graf.Canvas.MoveTo(W-6,acc_old_x + H2);
  Graf.Canvas.LineTo(W-1,trunc(x) + H2);
  acc_old_x:=trunc(x);


  Graf.Canvas.Pen.Color:=$000000ff;
  Graf.Canvas.Pen.Style:= psSolid;
  Graf.Canvas.MoveTo(W-6,acc_old_y + H2);
  Graf.Canvas.LineTo(W-1,trunc(y) + H2);
  acc_old_y:=trunc(y);


  Graf.Canvas.Brush.Color:=$00ffffff;
  Graf.Canvas.Pen.Color:=$00000000;
  Graf.Canvas.Pen.Style:= psDot;

  Graf.Canvas.MoveTo(0,(H-1) div 2);
  Graf.Canvas.lineTo(W - 1,(H-1) div 2);

  
end;

end.
